function findsaddle_experiment()
global fsad_name fsad_name_xyz fminname fminxyz

% Developed by Sebastian Sousa Castellanos, July 2016 

Na = 11; % the number of atoms for which you want to find saddles

APPEND = 1;
% parameters for saddle finding routine
Vtol = 1e-6;
tol = 1e-9;
R = [.001,.005,.01, 02,.04,.05,.07,.1]; % step sizes for minmode iterations which allows the user to find different saddles
lenR = length(R);
Nsteps = 20;
delta_min_eval = 1e-2;
eigcond0 = 0; % determines how long we follow the minmode
eigcondstep = 0.1;
Nfailmax = 3;
dir = sprintf('LJ%ddata',Na);


fsad_name = strcat(dir,sprintf('/LJ%dts_data.txt',Na));
fsad_name_xyz = strcat(dir,sprintf('/LJ%dts_xyz.txt',Na));
fminname = strcat(dir,sprintf('/LJ%dmin_data.txt',Na));
fminxyz = strcat(dir,sprintf('/LJ%dmin_xyz.txt',Na));
min_data = load(fminname);
minxyz = load(fminxyz);
Nmin = size(min_data,1);

if APPEND == 0
    Nsad = 0;
    jstart = 1;
end

if APPEND == 1
    sadlist = load(fsad_name);
    sadxyz = load(fsad_name_xyz);
    Nsad = size(sadlist,1);
    jstart = 1511;
% lostminlist = [
%         3123
%         2895
%         3532
% ];
% nlost = length(lostminlist);    
    
    
end

iter = 0;
Nmin0 = Nmin;
    for j = jstart : Nmin0
%        j = lostminlist(lostmin);
        fprintf('Min = %d, V = %d,\t Nsad = %d\n',j,min_data(j,1),Nsad);
        for evec = 1 : 2
            if evec == 1
                evecdir = -1;
            else
                evecdir = 1;
            end

            for k = 1 : lenR;
                eigcond = eigcond0;
                breakflag = 1;
                Nfail = 0;
                xyz_start = minxyz(3*j - 2 : 3*j,:);
                for i = 1 : Nsteps 
                    fprintf('k = %d\t istep = %d\t dir = %d\n',k,i,evecdir);
                    [xsad,vsad,freq,omega,flag,V1,V2,x1,x2,freq1,freq2,xyz_start] = ...
                        find_saddle_minmodedimer(xyz_start,eigcond,R(k),evecdir);
                    if flag == 1
                        isnewsaddle = 1;
                        if Nsad > 0
                            [Vdif, isad] = min(abs(vsad - sadlist(:,1)));
                            if Vdif < Vtol % this saddle has been already found

                                fprintf('Vdif = %d\n',Vdif);
                                fprintf('Matches saddle #%d, separating min %d and min %d\n',...
                                    isad,sadlist(isad,5),sadlist(isad,6));
                                isnewsaddle = 1 - align_configurations(sadxyz(isad*3-2:isad*3,:),xsad,1e-2);
                                breakflag = isnewsaddle;
                                fprintf('isnewsaddle = %d\n',isnewsaddle);
                            end
                        end
                        if isnewsaddle == 1 % record the new saddle
                            [dmin1 imin1] = min(abs(min_data(:,1) - V1));
                            if dmin1 < Vtol % run geometry test
                                 isnewmin1 = 1 - align_configurations(minxyz(imin1*3-2:imin1*3,:),x1,1e-2);
                            else
                                isnewmin1 = 1;
                            end
                            [dmin2 imin2] = min(abs(min_data(:,1) - V2));
                            if dmin2 < Vtol % run geometry test
                                 isnewmin2 = 1 - align_configurations(minxyz(imin2*3-2:imin2*3,:),x2,1e-2);
                            else
                                isnewmin2 = 1;
                            end
                            if isnewmin1 == 1
                                Nmin = Nmin + 1;
                                pgo = point_group_order(x1);
                                fprintf('New minimum %d is found: V = %.10f, pgo = %d\n',Nmin,V1,pgo);
                                minxyz = [minxyz; x1];
                                min_data = [min_data; V1,freq1,pgo];
                                printmin(V1,freq1,pgo,x1);
                                imin1 = Nmin;
                            end
                            if isnewmin2 == 1
                                Nmin = Nmin + 1;
                                pgo = point_group_order(x2);
                                fprintf('New minimum %d is found: V = %.10f, pgo = %d\n',Nmin,V2,pgo);
                                minxyz = [minxyz; x2];
                                min_data = [min_data; V2,freq2,pgo];
                                printmin(V2,freq2,pgo,x2);
                                imin2 = Nmin;
                            end
                            % record new saddle
                            Nsad = Nsad + 1;
                            sadxyz(Nsad*3-2:Nsad*3,:) = xsad;
                            pgo = point_group_order(xsad);
                            fprintf('Saddle %.10f separates min %d (%.10f) and min %d (%.10f)\n',vsad,imin1,V1,imin2,V2);
                            sadlist(Nsad,:) = [vsad,freq,omega,pgo,imin1,imin2];
                            printsad(vsad,freq,omega,pgo,imin1,imin2,xsad);
                            % update eigencondition for minmode
                            eigcond  = omega - delta_min_eval;
                        end
                    else % for if flag == 1, i.e.,if no saddle is found
                        eigcond = eigcond - eigcondstep;
                        Nfail = Nfail + 1;
                        if Nfail == Nfailmax
                            breakflag = 0;
                        end
                    end
                    fprintf('min = %d, Nsad = %d,Nmin = %d, k = %d, i = %d, flag = %d\n',j,Nsad,Nmin,k,i,flag);
                    if breakflag == 0 
                        break;
                    end
                end
            end
        end
    end

end

  
           
%%
%%
function printsad(v,freq,lam,pgo,m1,m2,xyz)
global fsad_name fsad_name_xyz
fsad = fopen(fsad_name,'a');
fsadxyz = fopen(fsad_name_xyz,'a');
fprintf(fsad,'%.10f\t%.10f\t%.10f\t%d\t%d\t%d\n',v,freq,lam,pgo,m1,m2);
fprintf(fsadxyz,'%.10f\t',xyz(1,:)); fprintf(fsadxyz,'\n');
fprintf(fsadxyz,'%.10f\t',xyz(2,:)); fprintf(fsadxyz,'\n');
fprintf(fsadxyz,'%.10f\t',xyz(3,:)); fprintf(fsadxyz,'\n');
fclose(fsad);
fclose(fsadxyz);
end
%%
function printmin(v,freq,pgo,xyz)
global fminname fminxyz
fmin = fopen(fminname,'a');
fxyz = fopen(fminxyz,'a');
fprintf(fmin,'%.10f\t%.10f\t%d\n',v,freq,pgo);
fprintf(fxyz,'%.10f\t',xyz(1,:)); fprintf(fxyz,'\n');
fprintf(fxyz,'%.10f\t',xyz(2,:)); fprintf(fxyz,'\n');
fprintf(fxyz,'%.10f\t',xyz(3,:)); fprintf(fxyz,'\n');
fclose(fmin);
fclose(fxyz);
end

%%
function flag = align_configurations(x,y,tol)
[x,Ngx,ngx,dx,ifx,ilx] = find_dist_groups(x);
[y,Ngy,ngy,dy,ify,ily] = find_dist_groups(y);
% centers of mass are put at the origin, particles at the origin, if any,
% are removed

flag = 0;
if Ngx == Ngy
    if ngx == ngy & max(abs(dx - dy)) < tol
        flag = 1;
    end
end
if flag == 0
    dist = 10;
    return;
end

% find three particles of conf x not lying in the same plane
ix1 = 1;
px1 = x(:,ix1);
px1 = px1/norm(px1);
g1 = find(ix1 >=ifx & ix1 <=ilx);

ix2 = ix1 + 1;
px2 = x(:,ix2);
px2 = px2/norm(px2);

while cross(px1,px2) < 0.1
    ix2 = ix2 + 1;
    px2 = x(:,ix2);
    px2 = px2/norm(px2);
end
g2 = find(ix2 >=ifx & ix2 <=ilx);

ix3 = ix2 + 1;
px3 = x(:,ix3);
px3 = px3/norm(px3);


while px3'*cross(px1,px2) < tol
    ix3 = ix3 + 1;
    px3 = x(:,ix3);
    px3 = px3/norm(px3);
end
g3 = find(ix3 >=ifx & ix3 <=ilx);

% find three particles of configuration y at the same distance from the
% origin and the same distances from each other as the selected above
% particles of configuration x
dist = 10;
for i = 1 : ngy(g1)
    iy1 = ify(g1) + i - 1;
    for j = 1 : ngy(g2)
        iy2 = ify(g2) + j - 1;
        if iy2 ~= iy1 & abs(norm(x(:,ix1)-x(:,ix2)) - norm(y(:,iy1)-y(:,iy2))) < tol 
            for k = 1 : ngy(g3)
                iy3 = ify(g3) + k - 1;
                if iy3 ~= iy2 & iy3 ~= iy1
                    if  abs(norm(x(:,ix1)-x(:,ix2)) - norm(y(:,iy1)-y(:,iy2))) < tol & ...
                            abs(norm(x(:,ix1)-x(:,ix3)) - norm(y(:,iy1)-y(:,iy3))) < tol & ...
                            abs(norm(x(:,ix2)-x(:,ix3)) - norm(y(:,iy2)-y(:,iy3))) < tol
                        % find the orthogonal transformation mapping
                        % y(:,[iy1,iy2,iy3]) to x(:,[ix1,ix2,ix3])
                        O = x(:,[ix1,ix2,ix3])*inv(y(:,[iy1,iy2,iy3])); 
                        dist = min(dist,dist_conf(x,O*y));
                        if dist < tol
                            break;
                        end
                    end
                end
                if dist < tol
                    break;
                end
            end
        end
        if dist < tol
            break;
        end
    end
    if dist < tol
        break;
    end
end

if dist < tol
    flag = 1;
else
    flag = 0;
end

end

%%
function [xyz,Ngroup,ngroup,d,ifirst,ilast] = find_dist_groups(xyz)
tol = 1e-3;
% place the center of mass into the origin
[m,Na] = size(xyz);
cmass = mean(xyz,2);
xyz = xyz - cmass*ones(1,Na);

% find distances from the origin and sort them
d = sqrt(sum(xyz.^2,1));
[dsort,isort] = sort(d,'descend');
xyz = xyz(:,isort);
d = dsort;


% if there are atoms at the center, remove them
while d(Na) < tol
    d(Na) = [];
    xyz(:,Na) = [];
    Na = Na - 1;
end

% group the distances
% Ngroup = the number of groups
% ngroup(k) = the number of atoms in group k
% ifirst(k) = the first atom in the group k
% ilast(k) = the last atom in the group k
Ngroup = 0; 
k = 0;
while k < Na
    Ngroup = Ngroup + 1;
    k = k + 1;
    ifirst(Ngroup) = k;
    while k < Na & abs(d(ifirst(Ngroup)) - d(k + 1)) < tol
        k = k + 1;
    end
    ilast(Ngroup) = k;
    ngroup(Ngroup) = k - ifirst(Ngroup) + 1; 
end
[gmin, jmin] = min(ngroup);
[gsort, jsort] = sort(ngroup,'ascend');
ngroup = gsort;
ifirst = ifirst(jsort);
ilast = ilast(jsort);
d = d(jsort);
% fprintf('Ngroup = %d\n',Ngroup);
% for j = 1 : Ngroup
%     fprintf('ifirst = %d, ilast = %d, ngroup = %d\n',ifirst(j),ilast(j),ngroup(j));
% end

end

%%
function dist = dist_conf(x,y)%simply matches
[m Na] = size(x);
r = zeros(Na,1);
for k = 1 : Na
    r(k) = min(sqrt(sum((x - y(:,k)*ones(1,Na)).^2,1))); % for atom k in y find the closest atom in x
end
dist = max(r);
end






