function remove_one_atom()
global  fminname fminxyz fminname1 fminxyz1 rstar
rstar = 2^(1/6);

% parameters for saddle finding routine
Vtol = 1e-6;
tol = 1e-9;
iter_max = 1000;
evaltol = 1e-3;

Na1 = 13;
Na = Na1 - 1;


dir1 = sprintf('LJ%ddata',Na1);
dir = sprintf('LJ%ddata',Na);


fminname1 = strcat(dir1,sprintf('/LJ%dmin_data.txt',Na1));
fminname = strcat(dir,sprintf('/LJ%dmin_data.txt',Na));
fminxyz1 = strcat(dir1,sprintf('/LJ%dmin_xyz.txt',Na1));
fminxyz = strcat(dir,sprintf('/LJ%dmin_xyz.txt',Na));
min_data1 = load(fminname1);
minxyz1 = load(fminxyz1);
min_data = load(fminname);
minxyz = load(fminxyz);
Nmin1 = size(min_data1,1);
Nmin = size(min_data,1);

fid = fopen(sprintf('Connect_data/AtomRemoval%dto%d.txt',Na1,Na),'w');

jstart = 1;
jfinish = Nmin1;

nomatch = 0;
for j = jstart : jfinish
    fprintf('Min = %d, V = %d\n',j,min_data1(j,1));
    xyz1 = minxyz1(3*j - 2 : 3*j,:);
    [v_detach,neib] = LJdetach(xyz1);
    for k = 1 : Na1
        if neib(k) < 8 % if atom has less than 8 nearest neighbors
            xyz_start = xyz1;
            xyz_start(:,k) = []; % remove atom k
            [xyz,V,freq,flag] = BFGS_trust_region(xyz_start,tol,iter_max);
%             fprintf('BFGS: flag = %d, imin = %d, atom = %d\n',flag,j,k)
            delta = 0.2;
            while flag ~= 1
                u = delta*(rand(size(xyz_start)) - 0.5);
                [xyz,V,freq,flag] = Newton_trust_region(xyz_start + u,tol,iter_max);
                fprintf('Newton: flag = %d, imin = %d, atom = %d\n',flag,j,k)
            end
            if flag == 1
                ind = find(abs(min_data(:,1) - V) < Vtol);
                metka = 0; % logical variable
                if ~isempty(ind)
                    metka = 1;
                    for i = 1 : length(ind)
                        match = align_configurations(minxyz(ind(i)*3-2 : ind(i)*3,:),xyz,1e-2);
                        if match == 1
                            metka = 2;
                            break;
                        end
                    end
                end
                if metka == 2 % found minimum matches minimum ind(i) of Na atoms
                    fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
%                     fprintf('%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
                end
                if metka == 1
                    nomatch = nomatch + 1;
                    fprintf('No match is found:min: %d, atom: %d, V_detach = %.10f, V = %.10f\n',j,k,-v_detach(k),V);
                    drawLJconf(xyz,nomatch);
                end
                if metka == 0
                    Nmin = Nmin + 1;
                    pgo = point_group_order(xyz);
                    fprintf('New minimum %d is found: min: %d, atom: %d, V_detach = %.10f, V = %.10f, pgo = %d\n',...
                        Nmin,j,k,-v_detach(k),V,pgo);
                    minxyz = [minxyz; xyz];
                    min_data = [min_data; V,freq,pgo];
                    printmin(V,freq,pgo,xyz);
                    fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,Nmin,-v_detach(k));
                    drawLJconf(xyz1,Nmin*10);
                    drawLJconf(xyz,Nmin);
                end
            end
            %%
%             fprintf('line 86: flag = %d\n',flag);
%             if flag == -1
%                 x = remove_rotations_translations(xyz);
%                 xi = x;
%                 vsad = LJpot(xi);
%                 H = LJhess(xi);
%                 [evec,eval] = eig(H);
%                 [evalsort,isort] = sort(diag(eval),'ascend');
%                 ind1 = find(evalsort < -evaltol);
%                 neg = length(ind1);
%                 ind2 = find(evalsort > evaltol);
%                 pos = length(ind2);
%                 fprintf('pos = %d, neg = %d\n',pos,neg);
% %                if neg == 1 & neg + pos == length(x) % Morse index 1 saddle is found
%                     omega = -evalsort(1);
%                     freq = sum(log(abs(evalsort)));
%                     dirneg = evec(:,isort(1));
%                     x = steepest_descend(xi + .1*dirneg);
%                     [xyz, V, freq, flag1] = BFGS_trust_region1(x);
%                     
%                     fprintf('line 105: flag1 = %d\n',flag1);
%                     if flag1 == 1
%                         ind = find(abs(min_data(:,1) - V) < Vtol);
%                         metka = 0; % logical variable
%                         if ~isempty(ind)
%                             metka = 1;
%                             for i = 1 : length(ind)
%                                 match = align_configurations(minxyz(ind(i)*3-2 : ind(i)*3,:),xyz,1e-2);
%                                 if match == 1
%                                     metka = 2;
%                                     break;
%                                 end
%                             end
%                         end
%                         if metka == 2 % found minimum matches minimum ind(i) of Na atoms
%                             fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
%         %                     fprintf('%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
%                         end
%                         if metka == 1
%                             nomatch = nomatch + 1;
%                             fprintf('No match is found:min: %d, atom: %d, V_detach = %.10f, V = %.10f\n',j,k,-v_detach(k),V);
%                             drawLJconf(xyz,nomatch);
%                         end
%                         if metka == 0
%                             Nmin = Nmin + 1;
%                             pgo = point_group_order(xyz);
%                             fprintf('New minimum %d is found: min: %d, atom: %d, V_detach = %.10f, V = %.10f, pgo = %d\n',...
%                                 Nmin,j,k,-v_detach(k),V,pgo);
%                             minxyz = [minxyz; xyz];
%                             min_data = [min_data; V,freq,pgo];
%                             printmin(V,freq,pgo,xyz);
%                             fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,Nmin,-v_detach(k));
%                             drawLJconf(xyz1,Nmin*10);
%                             drawLJconf(xyz,Nmin);
%                         end
%                     end
% 
%                     
%                     
%                     
%                     x = steepest_descend(xi - .1*dirneg);
%                     [xyz, V, freq, flag2] = BFGS_trust_region1(x);
%                     fprintf('line 147: flag2 = %d\n',flag2);
%                     if flag2 == 1
%                         ind = find(abs(min_data(:,1) - V) < Vtol);
%                         metka = 0; % logical variable
%                         if ~isempty(ind)
%                             metka = 1;
%                             for i = 1 : length(ind)
%                                 match = align_configurations(minxyz(ind(i)*3-2 : ind(i)*3,:),xyz,1e-2);
%                                 if match == 1
%                                     metka = 2;
%                                     break;
%                                 end
%                             end
%                         end
%                         if metka == 2 % found minimum matches minimum ind(i) of Na atoms
%                             fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
%         %                     fprintf('%d\t%d\t%d\t%.10f\n',j,k,ind(i),-v_detach(k));
%                         end
%                         if metka == 1
%                             nomatch = nomatch + 1;
%                             fprintf('No match is found:min: %d, atom: %d, V_detach = %.10f, V = %.10f\n',j,k,-v_detach(k),V);
%                             drawLJconf(xyz,nomatch);
%                         end
%                         if metka == 0
%                             Nmin = Nmin + 1;
%                             pgo = point_group_order(xyz);
%                             fprintf('New minimum %d is found: min: %d, atom: %d, V_detach = %.10f, V = %.10f, pgo = %d\n',...
%                                 Nmin,j,k,-v_detach(k),V,pgo);
%                             minxyz = [minxyz; xyz];
%                             min_data = [min_data; V,freq,pgo];
%                             printmin(V,freq,pgo,xyz);
%                             fprintf(fid,'%d\t%d\t%d\t%.10f\n',j,k,Nmin,-v_detach(k));
%                             drawLJconf(xyz1,Nmin*10);
%                             drawLJconf(xyz,Nmin);
%                         end
%                     end
% 
%                     
%                     if flag1 == 1 | flag2 == 1
%                         flag = 1;
%                     end
% 
% %                 else 
% %                     flag = 0;
% %                 end
%             end
% 
            %%
            if flag < 1
                fprintf('Minimum is not found for the removal from min %d of atom %d, V_detach = %.10f\n',j,k,-v_detach(k));
            end
        end
    end
end
fclose(fid);            
end

  
           
%%
%%
function printmin(v,freq,pgo,xyz)
global fminname fminxyz
fmin = fopen(fminname,'a');
fxyz = fopen(fminxyz,'a');
fprintf(fmin,'%.10f\t%.10f\t%d\n',v,freq,pgo);
fprintf(fxyz,'%.10f\t',xyz(1,:)); fprintf(fxyz,'\n');
fprintf(fxyz,'%.10f\t',xyz(2,:)); fprintf(fxyz,'\n');
fprintf(fxyz,'%.10f\t',xyz(3,:)); fprintf(fxyz,'\n');
fclose(fmin);
fclose(fxyz);
end

%%
function flag = align_configurations(x,y,tol)
[x,Ngx,ngx,dx,ifx,ilx] = find_dist_groups(x);
[y,Ngy,ngy,dy,ify,ily] = find_dist_groups(y);
% centers of mass are put at the origin, particles at the origin, if any,
% are removed

flag = 0;
if Ngx == Ngy
    if ngx == ngy & max(abs(dx - dy)) < tol
        flag = 1;
    end
end
if flag == 0
    dist = 10;
    return;
end

% find three particles of conf x not lying in the same plane
ix1 = 1;
px1 = x(:,ix1);
px1 = px1/norm(px1);
g1 = find(ix1 >=ifx & ix1 <=ilx);

ix2 = ix1 + 1;
px2 = x(:,ix2);
px2 = px2/norm(px2);

while cross(px1,px2) < 0.1
    ix2 = ix2 + 1;
    px2 = x(:,ix2);
    px2 = px2/norm(px2);
end
g2 = find(ix2 >=ifx & ix2 <=ilx);

ix3 = ix2 + 1;
px3 = x(:,ix3);
px3 = px3/norm(px3);


while px3'*cross(px1,px2) < tol
    ix3 = ix3 + 1;
    px3 = x(:,ix3);
    px3 = px3/norm(px3);
end
g3 = find(ix3 >=ifx & ix3 <=ilx);

% find three particles of configuration y at the same distance from the
% origin and the same distances from each other as the selected above
% particles of configuration x
dist = 10;
for i = 1 : ngy(g1)
    iy1 = ify(g1) + i - 1;
    for j = 1 : ngy(g2)
        iy2 = ify(g2) + j - 1;
        if iy2 ~= iy1 & abs(norm(x(:,ix1)-x(:,ix2)) - norm(y(:,iy1)-y(:,iy2))) < tol 
            for k = 1 : ngy(g3)
                iy3 = ify(g3) + k - 1;
                if iy3 ~= iy2 & iy3 ~= iy1
                    if  abs(norm(x(:,ix1)-x(:,ix2)) - norm(y(:,iy1)-y(:,iy2))) < tol & ...
                            abs(norm(x(:,ix1)-x(:,ix3)) - norm(y(:,iy1)-y(:,iy3))) < tol & ...
                            abs(norm(x(:,ix2)-x(:,ix3)) - norm(y(:,iy2)-y(:,iy3))) < tol
                        % find the orthogonal transformation mapping
                        % y(:,[iy1,iy2,iy3]) to x(:,[ix1,ix2,ix3])
                        O = x(:,[ix1,ix2,ix3])*inv(y(:,[iy1,iy2,iy3])); 
                        dist = min(dist,dist_conf(x,O*y));
                        if dist < tol
                            break;
                        end
                    end
                end
                if dist < tol
                    break;
                end
            end
        end
        if dist < tol
            break;
        end
    end
    if dist < tol
        break;
    end
end

if dist < tol
    flag = 1;
else
    flag = 0;
end

end

%%
function [xyz,Ngroup,ngroup,d,ifirst,ilast] = find_dist_groups(xyz)
tol = 1e-3;
% place the center of mass into the origin
[m,Na] = size(xyz);
cmass = mean(xyz,2);
xyz = xyz - cmass*ones(1,Na);

% find distances from the origin and sort them
d = sqrt(sum(xyz.^2,1));
[dsort,isort] = sort(d,'descend');
xyz = xyz(:,isort);
d = dsort;


% if there are atoms at the center, remove them
while d(Na) < tol
    d(Na) = [];
    xyz(:,Na) = [];
    Na = Na - 1;
end

% group the distances
% Ngroup = the number of groups
% ngroup(k) = the number of atoms in group k
% ifirst(k) = the first atom in the group k
% ilast(k) = the last atom in the group k
Ngroup = 0; 
k = 0;
while k < Na
    Ngroup = Ngroup + 1;
    k = k + 1;
    ifirst(Ngroup) = k;
    while k < Na & abs(d(ifirst(Ngroup)) - d(k + 1)) < tol
        k = k + 1;
    end
    ilast(Ngroup) = k;
    ngroup(Ngroup) = k - ifirst(Ngroup) + 1; 
end
[gmin, jmin] = min(ngroup);
[gsort, jsort] = sort(ngroup,'ascend');
ngroup = gsort;
ifirst = ifirst(jsort);
ilast = ilast(jsort);
d = d(jsort);
% fprintf('Ngroup = %d\n',Ngroup);
% for j = 1 : Ngroup
%     fprintf('ifirst = %d, ilast = %d, ngroup = %d\n',ifirst(j),ilast(j),ngroup(j));
% end

end

%%
function dist = dist_conf(x,y)%simply matches
[m Na] = size(x);
r = zeros(Na,1);
for k = 1 : Na
    r(k) = min(sqrt(sum((x - y(:,k)*ones(1,Na)).^2,1))); % for atom k in y find the closest atom in x
end
dist = max(r);
end

%%
%%
function [v_detach,neib] = LJdetach(xyz) % 
global rstar
[m Na] = size(xyz);
r = zeros(Na);
neib = zeros(Na,1);
for k = 1 : Na
    r(k,:) = sqrt(sum((xyz - xyz(:,k)*ones(1,Na)).^2,1));
    ind = find(abs(r(k,:) - rstar) < 0.15);
    if ~isempty(ind)
        neib(k) = length(ind);
    end
end
r = r + diag(ones(Na,1));
aux = 1./r.^6;
L = (aux - 1).*aux;
L = L - diag(diag(L));
v_detach = 4*sum(L,2);
end
%%

function [xyz Vxyz freq flag] = BFGS_trust_region1(x)
    N = length(x);
    Na = N/3 + 2;
    tol = 1e-9;
    iter_max = 1000;
    [f, g] = LJ(x);
    nor = norm(g);
    Rmax = 0.1; % the maximal trust region radius
    R = 0.05;
    Rmin = 1e-14;
    rho_good = 0.75;
    rho_bad = 0.25;
    eta = 0.01;

%     fprintf('Initially, V = %d\t, |grad V| = %d\n',f,nor); 
    %% The trust region BFGS method
    tic
    
    iter = 0;
    feval = 0;
    flag = 0;
    I = eye(length(x));
    B = I;
    while nor > tol & iter < iter_max
        % solve the constrained minimization problem using dogleg strategy
        pu = -g*(g'*g)/(g'*B*g);
        pb = -B\g;
        normpu = norm(pu);
        normpb = norm(pb);
        if normpu > R 
            p = R*pu/normpu;
        else
            if normpb < R
                p = pb;
            else
                d = pb - pu;
                alp = max(roots([d'*d, 2*pu'*d, pu'*pu - R^2]));                
                p = pu + alp*d;
            end
        end
        iter = iter + 1;        
        % assess the progress
        xnew = x + p;
        [fnew, gnew] = LJ(xnew);
        mnew = f + g'*p + 0.5*p'*B*p;
%        fprintf('f = %d\tfnew = %d\t mnew = %d\n',f,fnew,mnew);
        rho = (f - fnew+1e-14)/(f - mnew+1e-14);
        % adjust the trust region
        if rho < rho_bad
            R = max([0.25*R,Rmin]);
        else
            if rho > rho_good & abs(norm(p) - R) < tol
                R = min([Rmax,2*R]);
            end
        end
        % accept or reject step
        if rho > eta            
            s = xnew - x;
            y = gnew - g;
            aux = B*s;
            B = B - (aux*aux')/(s'*aux) + y*y'/(y'*s);
            x = xnew;
            f = fnew;
            g = gnew;
            nor = norm(g);
%            fprintf('Accept: iter = %d, rho = %d\t f = %d, |grad f| = %d, R = %d\n',iter,rho,f,nor,R);
        else
%            fprintf('Reject: iter = %d,rho = %d\n',iter,rho);
        end
    end
    if iter == iter_max
        flag = -1;
    end
    cputime = toc;
    %% check what is found
    if flag == 0
        fprintf('Result: f = %.8f\t |df| = %d\t niter = %d\n',f,nor,iter);
        H = LJhess(x);
        ihess = sort(eig(H),'ascend');
        freq = sum(log(abs(ihess)));
        if ihess(1) > 0 % if a nondegenerate minimum is found
            flag = 1;
            MorseIndex = 0;
        else
            flag = -1;
        end
        Vxyz = LJpot(x);
        x_aux = [0;0;0;x(1);0;0;x(2:3);0;x(4:N)];
        xyz = reshape(x_aux,3,Na);
    else
        fprintf('BFGS trust region method failed to find a minimum\n');
        xyz = 0;
        freq = 0;
        flag = 0;
        Vxyz = 0;
    end
        

end

%%

function x = steepest_descend(x)
tol = 1e-1;
iter = 0;
iter_min = 50;
g = LJgrad(x);
nor = norm(g);
dt = 1e-3;
% fprintf('SD: iter = %d\t V = %d\n',iter,LJpot1(x));

while iter < iter_min | nor > tol
    x = x - dt*g;
    g = LJgrad(x);
    nor = norm(g);
    iter  = iter + 1;
%    fprintf('SD: iter = %d\t V = %d\n',iter,LJpot1(x));

end
fprintf('SD: iter = %d\t V = %d\n',iter,LJpot(x));
end

%%

%% Lennard-Jones potential        

function v = LJpot(xyz) % 
[m n] = size(xyz);
Na = (m + 6)/3 ;
x_aux = [0;0;0;xyz(1);0;0;xyz(2:3);0;xyz(4:m)];
m = length(x_aux);
% restore atomic coordinates 
x = reshape(x_aux,3,Na);
r = zeros(Na); 
%Matrix of pair wise distances:
for k = 1 : Na
    r(k,:) = sqrt(sum((x - x(:,k)*ones(1,Na)).^2,1)); %the one is direction one, down the column.
end
r = r + diag(ones(Na,1)); 
aux = 1./r.^6;
L = (aux - 1).*aux;
L = L - diag(diag(L)); %Get rid of what is in line 179, turns them back to zeros.
v = 2*sum(sum(L)); %Just by two instead of four, since we counted each distance between atoms twice.
end
 
 %%
function dv = LJgrad(xyz) % 
[m n] = size(xyz);
Na = (m + 6)/3 ;
x_aux = [0;0;0;xyz(1);0;0;xyz(2:3);0;xyz(4:m)];
m = length(x_aux);
% restore atomic coordinates
g = zeros(size(x_aux));
x = reshape(x_aux,3,Na);
r = zeros(Na);
for k = 1 : Na
    r(k,:) = sqrt(sum((x - x(:,k)*ones(1,Na)).^2,1));
end
r = r + diag(ones(Na,1));
L = -6*(2./r.^6 - 1)./r.^8;
for k = 1 : Na
    Lk = L(:,k);
    g(1 + (k-1)*3 : k*3) = (x(:,k)*ones(1,Na) - x)*Lk;
end

g = 4*g;
dv = g([4,7,8,10 : Na*3]);
end

%%
function [v dv] = LJ(xyz) % 
[m n] = size(xyz);
Na = (m + 6)/3 ;
x_aux = [0;0;0;xyz(1);0;0;xyz(2:3);0;xyz(4:m)];
m = length(x_aux);
% restore atomic coordinates 
x = reshape(x_aux,3,Na);
r = zeros(Na);
for k = 1 : Na
    r(k,:) = sqrt(sum((x - x(:,k)*ones(1,Na)).^2,1));
end
r = r + diag(ones(Na,1));
aux = 1./r.^6;
L = (aux - 1).*aux;
L = L - diag(diag(L));
v = 2*sum(sum(L));

g = zeros(size(x_aux));
L = -6*(2./r.^6 - 1)./r.^8;
for k = 1 : Na
    Lk = L(:,k);
    g(1 + (k-1)*3 : k*3) = (x(:,k)*ones(1,Na) - x)*Lk;
end

g = 4*g;
dv = g([4,7,8,10 : Na*3]);

end
 %%
function H = LJhess(x) % find the Hessian using finite differences
h = 1e-4;
n = length(x);
H = zeros(n);
e = eye(n);
for i = 1 : n
    di = e(:,i)*h;
    Hei = 0.5*(LJgrad(x + di) - LJgrad(x - di))/h;
    for j = 1 : i
        H(j,i) = e(j,:)*Hei;
        H(i,j) = H(j,i);
    end
end
end



